package br.com.buscaacelerada;

import android.app.ListActivity;
import android.content.Intent;
import android.os.Bundle;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.Vector;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.StatusLine;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import com.jsonsample.R;

import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.ListView;

public class ResultsActivity extends ListActivity {

	static JSONArray jsonArray;
	
  @Override
  public void onCreate(Bundle savedInstanceState) {
    super.onCreate(savedInstanceState);
    setContentView(R.layout.main);
    
    Intent intent = getIntent();
    String readTwitterFeed = readBuscaAceleradaFeed(intent.getStringExtra("Pesquisa"));
    Vector<String> tweets = new Vector<String>();
    
    try {
      jsonArray = new JSONArray(readTwitterFeed);
      for (int i = 0; i < jsonArray.length(); i++) {
        JSONObject jsonObject = jsonArray.getJSONObject(i);
        tweets.add(jsonObject.getString("Titulo"));
      }
    } catch (Exception e) {
      e.printStackTrace();
    }
    
	setListAdapter(new ArrayAdapter<String>(this, android.R.layout.simple_list_item_1, tweets));
  }
  
  public void onListItemClick(ListView parent, View v, int position, long id){
	  
	  Intent intent = new Intent(ResultsActivity.this, FormActivity.class);
	  
	  try {
		JSONObject jsonObject = jsonArray.getJSONObject(position);
		intent.putExtra("Titulo", jsonObject.getString("Titulo"));
		intent.putExtra("Ano", jsonObject.getString("Ano"));
		intent.putExtra("Preco", jsonObject.getString("Preco"));
		//intent.putExtra("Link", "http://buscaacelerada.com.br/anuncio/" + jsonObject.getString("Hash"));
		intent.putExtra("Link", jsonObject.getString("Imagem"));
		intent.putExtra("Cor", jsonObject.getString("Cor"));
		intent.putExtra("NomeCidade", jsonObject.getString("NomeCidade"));
			
	  } catch (JSONException e) {
	      e.printStackTrace();
	  }
	  
	  startActivity(intent);
  }
  
  public boolean onCreateOptionsMenu(Menu menu){
	  super.onCreateOptionsMenu(menu);
	  menu.add(1,1,1, "Buscar Anúncios");
	  menu.add(1,2,2, "Ver Favoritos");
	  return true;
  }
  
  public boolean onOptionsItemSelected(MenuItem item){
	
	  int id = item.getItemId();
	  if(id == 1){
		  finish();//volta para tela de pesquisar
	  }
	  else if(id == 2){//ver favoritos
		  Intent intent = new Intent(ResultsActivity.this, FavoritesActivity.class);
		  startActivity(intent);
		  finish();
	  }
	  else{
		  super.onOptionsItemSelected(item);
	  }
	  return true;
  }

  public String readBuscaAceleradaFeed(String search) {
    StringBuilder builder = new StringBuilder();
    HttpClient client = new DefaultHttpClient();
    HttpGet httpGet = new HttpGet("http://buscaacelerada.com.br/services/SearchService.svc/Pesquisa/" + search.toUpperCase());
    try {
      HttpResponse response = client.execute(httpGet);
      StatusLine statusLine = response.getStatusLine();
      int statusCode = statusLine.getStatusCode();
      if (statusCode == 200) {
        HttpEntity entity = response.getEntity();
        InputStream content = entity.getContent();
        BufferedReader reader = new BufferedReader(new InputStreamReader(content));
        String line;
        
        while ((line = reader.readLine()) != null) {
        	builder.append(line);
        }
      } 
      else 
      {
        Log.e(ResultsActivity.class.toString(), "Falha ao conectar na API");
      }
    } catch (ClientProtocolException e) {
      e.printStackTrace();
    } catch (IOException e) {
      e.printStackTrace();
    }
    return builder.toString();
  }
} 